<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This page is for global configuration variable administration.
 */

require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
?>
<html><head>
<title>Network Interface Statistics Collection Agent - Global Variables</title>
<style type="text/css"><? echo "
*.f_g_bg      { color: #$graph_text; background-color: #$graph_background; }
*.f_g_text    { color: #$graph_text; background-color: #$graph_background; }
*.f_g_lborder { color: #$graph_border_light; background-color: #$graph_background; }
*.f_g_dborder { color: #$graph_border_dark; background-color: #$graph_background; }
*.f_g_peak    { color: #$graph_peak_highlight; background-color: #$graph_background; }
*.f_g_in      { color: #$graph_incoming_data; background-color: #$graph_background; }
*.f_g_out     { color: #$graph_outgoing_data; background-color: #$graph_background; }
*             { font-family: $fontface; }
";
?></style>

<script language="Javascript">
// Browser sniffer.
var agent=navigator.userAgent.toLowerCase();
var incapable=false;
if (agent.indexOf('mozilla/4') != -1 && agent.indexOf('msie') == -1) {
  incapable=true;
}

// For the interactive color creation popup window.
function loadPopup() {
  var feats='width=500,height=300,scrollbars=yes,resizeable=yes,toolbar=no,location=no,directories=no,status=no,menubar=no';
  window.open('adm_colors.html', '', feats);
}

// Changes the appropriate colors in the CSS for the right elements as the values are changed.
function colorswitch(fld) {
  if(!document.styleSheets && document.getElementsByTagName) {
// Gotta make our own styleSheets array.
    document.styleSheets=[];
    document.styleSheets.concat(document.getElementsByTagName('STYLE'));
  }
  if(!document.styleSheets) {
// Incapable browser. Upgrade! :)
    return;
  }
  var col=eval("document.adm_form."+fld+".value");
  var flds=new Array("f_g_bg", "f_g_text","f_g_lborder","f_g_dborder","f_g_peak","f_g_in","f_g_out");
  var i, j, cls;
  if(!document.styleSheets[0].cssRules) {
//IE Browser.
    cls=document.styleSheets[0].rules;
  } else {
// not IE.
    cls=document.styleSheets[0].cssRules;
  }
  if (fld=="f_g_bg") {
// Change background color in all seven classes.
    for (i=0; i<flds.length; i++) {
      cls[i].style.backgroundColor=col;
    }
  } else {
    for (j=0; j<flds.length; j++) {
// Find the right class name.
      if (flds[j]==fld) { break; }
    }
// Change this class' text color.
    cls[j].style.color=col;
    if (fld=="f_g_text") {
// Also change the "Background" field's text display.
      cls[0].style.color=col;
    }
  }
}
</script>

</head>
<?
echo default_body() . titlebar("Global Variables Administration");
$helpname="globals"; require_once($location["help"]);
?>

<hr size=1 noshade>
<?
if ($msg=="baddelay") {
  print_error("You entered an invalid delay time (\"$d\").");
  echo "<hr noshade size=1>\n";
}
if ($msg=="badcolor") {
  print_error("You specified an illegal color for graphing (\"$color\"). Colors must be in the form of standard hexadecimal HTML color codes.");
  echo "<hr noshade size=1>\n";
}
if ($msg=="badstats") {
  print_error("The stats file you specified (\"$file\") does not exist or is not readable.");
  echo "<hr noshade size=1>\n";
}
if ($msg=="badfont") {
  print_error("The font file you specified (\"$file\") does not exist or is not readable.");
  echo "<hr noshade size=1>\n";
}
if ($msg=="badx") {
  print_error("You specified an invalid graph width (\"$bx\").");
  echo "<hr noshade size=1>\n";
}
if ($msg=="bady") {
  print_error("You specified an invalid graph height (\"$by\").");
  echo "<hr noshade size=1>\n";
}
if ($msg=="baddate") {
  print_error("You specified a blank date format.");
  echo "<hr noshade size=1>\n";
}
?>
<P>
Edit the variables and submit the form.
</P>
<hr noshade size=1>
<P>
<form method=POST action="adm_globals2.php" name="adm_form">
<table border=1 cellspacing=5 cellpadding=2>
<tr><th colspan=2 align=left><I>Global Options</I></th></tr>

<tr><td>How often do you want the collector scripts to run (in seconds)?</td>
<td>
<input type=text name="f_delay" size=4 value="<? echo $delay; ?>">
</td></tr>

<tr><td>Enter the location of your procfs statistics file (<tt>/proc/net/dev</tt> in Linux) for non-SNMP collection from localhost:</td>
<td><input type=text name="f_statsfile" size=20 value="<? echo $statsfile; ?>">
</td></tr>

<tr><td>Do you want reports displayed using bits or bytes?<BR>
(This is just a default; you can change it on the report form.)</td>
<td>
<input type=radio name="f_bitbyte" value="b"<? if ($bitbyte == "b") { echo " checked"; } ?>> Bits<BR>
<input type=radio name="f_bitbyte" value="B"<? if ($bitbyte != "b") { echo " checked"; } ?>> Bytes
</td></tr>

<tr><td>Do you want the fancy Javascript hostname/interface selection method on the index form?</td>
<td>
<input type=radio name="f_js_list" value="y"<? if ($js_list != "") { echo " checked"; } ?>> Yes<BR>
<input type=radio name="f_js_list" value="n"<? if ($js_list == "") { echo " checked"; } ?>> No
</td></tr>

<input type=hidden name="f_have_gd" value="<? if ($have_gd == "") { echo "n"; } else { echo "y"; } ?>">

<tr><td>If your GD Library supports TrueType fonts, enter the font to use here.
This should be a full path and filename ending in ".ttf".
If you leave it blank, or don't have TTF support, the GD Library's internal fonts will be used.</td>
<td><? if (function_exists("imagettftext")) {
  echo "<input type=text name=\"f_ttf_font\" size=35 value=\"$ttf_font\">\n";
} else {
  echo "You have no Truetype Font support. <TT>:'(</TT>\n";
  echo "<input type=hidden name=\"f_ttf_font\" value=\"\">\n";
}
?></td></tr>

<tr><td>Would you prefer having graphs generated as JPG or PNG files?<BR>
(This is just a default; you can change it on the report form.)</td>
<td>
<input type=radio name="f_graph_fmt" value="j"<? if ($graph_fmt == "j") { echo " checked"; } ?>> JPG<BR>
<input type=radio name="f_graph_fmt" value="p"<? if ($graph_fmt == "p") { echo " checked"; } ?>> PNG
</td></tr>

<tr><td>Enter the format you'd like to use for full dates/times in reports.
This format will be applied to everything <I>except</I> the X-axis date/time labels on graphs.
The following characters are used to create a date format string;
use whatever separator characters (<tt>"/", ":", ",", " ",</tt> etc) you wish:

<DL>
<DT><I>Year:</I>
<DD><B>Y</B> - 4-digits
<DD><B>y</B> - 2-digits

<DT><I>Month:</I>
<DD><B>n</B> - number without leading zeroes
<DD><B>m</B> - 2-digit number
<DD><B>M</B> - 3-letter abbreviation
<DD><B>F</B> - full name

<DT><I>Day:</I>
<DD><B>j</B> - number without leading zeroes
<DD><B>d</B> - 2-digit number
<DD><B>D</B> - 3-letter abbreviation
<DD><B>l</B> - full name (lower-case "L")
<DD><B>z</B> - Julian date (day number of the year)
<DD><B>S</B> - 2-digit suffix ("st", "nd", "rd", "th")

<DT><I>Hour:</I>
<DD><B>g</B> - 12-hour without leading zeroes
<DD><B>G</B> - 24-hour without leading zeroes
<DD><B>h</B> - 2-digit 12-hour
<DD><B>H</B> - 2-digit 24-hour
<DD><B>a</B> - &quot;am/pm&quot;
<DD><B>A</B> - &quot;AM/PM&quot;

<DT><I>Minute:</I>
<DD><B>i</B> - 2-digit number (lower-case "I")

<DT><I>Second:</I>
<DD><B>s</B> - 2-digit number

<DT><I>Misc:</I>
<DD><B>U</B> - Unix epoch timestamp; i.e., "<?
echo date("U");
?>"
<DD><B>T</B> - Time zone of this machine; i.e., "<?
echo date("T");
?>"
<DD><B>r</B> - RFC 822 formatted date; i.e., "<?
echo date("r");
?>"

</DL><I>Current format:</I> <B><? echo date($dateformat); ?>
</td>
<td valign=bottom><input type=text name="f_dateformat" size=30 value="<? echo $dateformat; ?>">
</td></tr>

<tr><td>Enter the format you'd like to apply to <I>dates</I> on the X-axis graph labels.
<BR><I>Current format:</I> <B><? echo date($dformat); ?>
</td>
<td valign=bottom><input type=text name="f_dformat" size=30 value="<? echo $dformat; ?>">
</td></tr>

<tr><td>Enter the format you'd like to apply to <I>times</I> on the X-axis graph labels.
<BR><I>Current format:</I> <B><? echo date($tformat); ?>
</td>
<td valign=bottom><input type=text name="f_tformat" size=30 value="<? echo $tformat; ?>">
</td></tr>

<tr><td>Enter the width and height you want graphs to be by default:</td>
<td>
<table border=0 cellpadding=3 cellspacing=0>
<tr>
<td align=right>Width:</td><td><input type=text name="f_X" size=5 value="<? echo $X; ?>"></td></tr>
<td align=right>Height:</td><td><input type=text name="f_Y" size=5 value="<? echo $Y; ?>"></td></tr>
</table>
</td></tr>

<tr><td>
Enter the default colors you want used in the graphs.
Use standard hex color codes. The current color scheme is displayed; the "Background"
color is used under all color choices, of course. Any colors that aren't defined yet
because you've just imported an older database into your new one will show up in the
"Text" color. As you change values here, the colors will change to match your choices...
assuming you have Javascript and CSS enabled and aren't using Netscape 4. :)
<P>
<input type=button value=" Click Here " onClick="loadPopup()"><BR>
for an interactive color-creation popup window.<BR>
</td>
<td>
<table border=0 cellpadding=4 cellspacing=0>
<?
echo "<tr><td class=\"f_g_bg\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_text>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_bg');\" type=text name=\"f_g_bg\" size=6 maxlength=6 value=\"$graph_background\"></td>
<td>$font2&nbsp;Background</td>
</tr>

<tr><td class=\"f_g_text\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_text>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_text');\" type=text name=\"f_g_text\" size=6 maxlength=6 value=\"$graph_text\"></td>
<td>$font2&nbsp;Text</td>
</tr>

<tr><td class=\"f_g_lborder\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_border_light>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_lborder');\" type=text name=\"f_g_lborder\" size=6 maxlength=6 value=\"$graph_border_light\"></td>
<td>$font2&nbsp;Light Border</td>
</tr>

<tr><td class=\"f_g_dborder\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_border_dark>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_dborder');\" type=text name=\"f_g_dborder\" size=6 maxlength=6 value=\"$graph_border_dark\"></td>
<td>$font2&nbsp;Dark Border</td>
</tr>

<tr><td class=\"f_g_peak\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_peak_highlight>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_peak');\" type=text name=\"f_g_peak\" size=6 maxlength=6 value=\"$graph_peak_highlight\"></td>
<td>$font2&nbsp;Peak Highlight</td>
</tr>

<tr><td class=\"f_g_in\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_incoming_data>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_in');\" type=text name=\"f_g_in\" size=6 maxlength=6 value=\"$graph_incoming_data\"></td>
<td>$font2&nbsp;Incoming Data</td>
</tr>

<tr><td class=\"f_g_out\" align=right bgcolor=#$graph_background>$font2
<script language=\"Javascript\">
if (incapable) { document.write('<font color=#$graph_outgoing_data>'); }
</script>
Sample Text</td>
<td><input onChange=\"colorswitch('f_g_out');\" type=text name=\"f_g_out\" size=6 maxlength=6 value=\"$graph_outgoing_data\"></td>
<td>$font2&nbsp;Outgoing Data</td>
</tr>
";
?></table>
</td></tr>

<tr><td colspan=2 bgcolor=#000000><img src="1x1.gif" height=1></td></tr>
<tr><th colspan=2>The options below apply <I>only</I> to the "nisca_check" script.</th></tr>
<tr><td>Enter the email address of the person the checker script should send
mail to whenever it has to restart a collector. If left blank, no mail will be sent.
</td>
<td valign=bottom><input type=text name="f_mailto" size=40 value="<? echo $mailto; ?>">
</td></tr>

<tr><td>Enter the command that the checker script should run to start the "collect"
script. If left blank, "collect" will neither be checked for nor ever started by
the checker script.<BR>
Note this command <B>has</B> to be put into the background with "&amp;", <I>and</I>
its output <B>must</B> be redirected to some file (like <TT>/dev/null</TT>)!!!
Otherwise "nisca_check" will never exit.<BR>
Default is "<TT>nohup /usr/sbin/collect > /dev/null &</tt>".
</td>
<td valign=bottom><input type=text name="f_collect_cmd" size=40 value="<? echo $collect_cmd; ?>">
</td></tr>

<tr><td>Enter the command that the checker script should run to start the "snmp_collect"
script. If left blank, "snmp_collect" will neither be checked for nor ever started by
the checker script.<BR>
Note this command <B>has</B> to be put into the background with "&amp;", <I>and</I>
its output <B>must</B> be redirected to some file (like <TT>/dev/null</TT>)!!!
Otherwise "nisca_check" will never exit.<BR>
Default is "<TT>nohup /usr/sbin/snmp_collect > /dev/null &</tt>".
</td>
<td valign=bottom><input type=text name="f_snmp_cmd" size=40 value="<? echo $snmp_cmd; ?>">
</td></tr>

<tr><td>Enter an appropriate "ps" command for your operating system/platform. The options
you use on it should return a "wide" result; that is, set it so that it doesn't truncate
what it returns. On Linux, this is the "w" option to ps. Linux users should use
"ps axw" here, for example.
</td>
<td valign=bottom><input type=text name="f_ps_cmd" size=40 value="<? echo $ps_cmd; ?>">
</td></tr>

<tr><td align=center colspan=2><input type=submit value=" Update Settings "></td></tr>
</table>
</form>
<hr noshade size=1>
<P>
<a href="<? echo $location["admin"]; ?>/">Administration Menu</a>
</P>
</body></html>
