<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This is where you set options for this host and which
 interfaces to monitor on it via SNMP.
 */

if ($host=="" || $method=="") {
  header("Location: adm_hosts1.php");
  die;
}
require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
error_reporting(0);

if (trim($interfaces[$host][0]["method"]) != "") {
  $m=$interfaces[$host][0]["method"];  
} else {
  $m=$method;
}
$oid=set_oids();
$comms=trim($comms);
if ($comms != "") {
  if (! $communes=preg_split('/\s*,\s*/', $comms)) {
    $communes=array();
    $communes[0]=$comms;
  } else {
    $cout=array();
    foreach ($communes as $c) {
      if (trim($c) != "") {
        $cout[]=$c;
      }
    }
    $communes=$cout;
  }
}
?>
<html><head>
<title>Network Interface Statistics Collection Agent - SNMP Interface Selection 1</title>
<style type="text/css">
* { font-family: <? echo $fontface; ?>; }
</style>
</head>
<?
echo default_body() . titlebar("SNMP Host Administration");
$helpname="snmp_if3"; require_once($location["help"]);
?>
<hr size=1 noshade>
<P>
<form method=POST action="adm_snmp3.php">
<input type=hidden name="host" value="<? echo $host; ?>">
<input type=hidden name="comms" value="<? echo $comms; ?>">
<input type=hidden name="method" value="<? echo $method; ?>">
<?
if ($m != $method) {
  echo "<input type=hidden name=\"oldmethod\" value=\"$m\">\n";
}
$v2capable="y";
// Walk all the interesting things for this host. We always need System...
// It's the only one we only need to get for one community though.
$system=mysnmpwalkoid($host, $communes[0], $oid["System"], $v2capable, TRUE);
if ($system===FALSE) {
// This means this host cannot do snmpv2c. Have to do it the slow, non-bulk way.
  $v2capable="";
  $system=mysnmpwalkoid($host, $communes[0], $oid["System"], $v2capable, TRUE);
}
if ($system===FALSE) {
// This means something else entirely.. wrong community or something.
  print_error("This host wouldn't answer to the \"system\" OID on the " .
              "\"{$communes[0]}\" communtiy; this page may not be that useful.");
}

echo "<P><B>Host Information</B><BR>\n<table border=1>\n";
  
echo "<tr><td align=right valign=top>$font2<B>SNMPv2c Capable?</td>";
if (trim($v2capable)=="") { $a="No"; }
else { $a="Yes"; }
echo "<td>$font2" . nl2br($a) . "</td></tr>\n";

echo "<tr><td align=right valign=top>$font2<B>Description</td>";
$a=$system[$oid["sysDescr"]];
if (trim($a)=="") { $a="<I>None Found</I>"; }
echo "<td>$font2" . nl2br($a) . "</td></tr>\n";

echo "<tr><td align=right valign=top>$font2<B>Uptime</td>";
$a=$system[$oid["sysUpTime"]];
if (trim($a)=="") { $a="<I>None Found</I>"; }
echo "<td>$font2$a</td></tr>\n";

echo "<tr><td align=right valign=top>$font2<B>Contact</td>";
$a=$system[$oid["sysContact"]];
if (trim($a)=="") { $a="<I>None Found</I>"; }
echo "<td>$font2$a</td>\n";

echo "<tr><td align=right valign=top>$font2<B>Location</td>";
$a=$system[$oid["sysLocation"]];
if (trim($a)=="") { $a="<I>None Found</I>"; }
echo "<td>$font2$a</td>\n";

echo "</tr></table>\n<P><B>Host Alias</B><BR>\n<input type=text name=\"hostalias\" size=50 value=\"";
if ($interfaces[$host][0]["hostalias"] != "") {
  echo $interfaces[$host][0]["hostalias"];
} elseif ($system[$oid["sysName"]] != "") {
  $a=$system[$oid["sysName"]];
  echo $a;
} else {
  echo $host;
} 
echo "\">\n";
?>
<P>
<input type=checkbox name="dynamo"<?
if ($interfaces[$host][0]["dynamic"] != "") { echo " checked"; }
?>> <B>Dynamic Collection</B>
</P>

<hr noshade size=1>
<P>
Select interface options below for the host <?
  echo "\"$host\"";
?>.<BR>
<font size=2>
Interface names which appear in <font color=#CC3366><B>this color</B></font>
support 64-bit counters; the uncolored ones do not.<BR>
Currently using the "<B><? echo $method; ?></B>" method to identify interfaces<?
if ($m != $method) {
  echo " (<font color=#cc0000>Warning:</font> the method has changed from \"<B>$m</B>\")";
}
?>;<BR>
interfaces which do not return a result for this will not show up here, and you'll be
unable to collect statistics on them unless you find a naming method they respond to.</font></P>
<?

// Get the name-to-number map for this host.
$nums=$ifdescr=array();
foreach ($communes as $ctmp) {
  $ifentries=mysnmpwalkoid($host, $ctmp, $oid["ifEntry"], $v2capable, TRUE);
// If the $method is in $odd_oids, we'll need it too.
  if (in_array($method, $odd_oids)) {
    $tmp2=mysnmpwalkoid($host, $ctmp, $oid[$method], $v2capable, TRUE);
    $ifentries=array_merge($ifentries, $tmp2);
  }
// And we'll need the ifXEntry tree if $method isn't in $ifentries by this point.
  if (!in_array($method, $oid)) {
    $tmp2=mysnmpwalkoid($host, $ctmp, $oid["ifXEntry"], $v2capable, TRUE);
    $ifentries=array_merge($ifentries, $tmp2);
  }
  if ($ifentries===FALSE) {
    print_error("Couldn't get any MIB trees from the \"$ctmp\" community!");
  }
  $ifentries=result_fix($ifentries);

// Suck out IF names, ifDescr, ifSpeed, and ifAlias for this community.
  $ifnamess=oid_suck($ifentries, $oid[$method]);
  $ifdescrs=oid_suck($ifentries, $oid["ifDescr"]);
  $ifspeeds=oid_suck($ifentries, $oid["Speed"]);
  $ifaliass=oid_suck($ifentries, $oid["Alias"]);

  unset($oldifnamess);
  foreach(array_keys($ifnamess) as $k) {
    $if_num=preg_replace('/^.+\.(\d+)$/', '\\1', $k);
    $name=$ifnamess[$k];
    if (trim($name) != "") {
      $nums[$ctmp][$name]=$if_num;
// I'll be nice and show you the ifDescr entry anyway if that's not your chosen method.
      if ($method != "ifDescr" && $ifdescrs[$oid["ifDescr"] . ".$if_num"] != "") {
        $ifdescr[$ctmp][$if_num]=$ifdescrs[$oid["ifDescr"] . ".$if_num"];
      } else {
        $ifdescr[$ctmp][$if_num]="";
      }
// If they changed the method, get the OLD name-to-number map.
      if ($m != $method) {
        if (!is_array($oldifnamess)) {
          $oldifnamess=oid_suck($ifentries, $oid[$m]);
          if (count($oldifnamess) < 1) {
// We didn't catch the old method, $m, when walking earlier. Get it now.
            $oldifnamess=result_fix(mysnmpwalkoid($host, $ctmp, $oid[$m], $v2capable, TRUE));
          }
        }
        if ($oldifnamess[$oid[$m].".$if_num"] != "") {
          $oldname[$ctmp][$name]=$oldifnamess[$oid[$m].".$if_num"];
        } else {
          $oldname[$ctmp][$name]="";
        }
      }
    }
  }
}

// Returns array like: $newiflist[community]=array("if1", "if2", ...)
$newiflist=get_interfaces($host, $communes, $method);
if ($newiflist["-msgs-"][0] != "") {
  echo "<P>{$newiflist["-msgs-"][0]}</P>\n";
}

if (count($newiflist)< 1) {
  echo "<P>No interfaces found on any specified community on \"$host\"!</P>\n";
} else {
  $rowspan=0;
  foreach ($newiflist as $c) {
    $rowspan += count($c);
  }
  $rowspan *= 2;
  echo "<table border=0 cellspacing=4 cellpadding=0>\n" .
       "<tr><td>$font2"."On</td>\n" .
       "<td rowspan=$rowspan bgcolor=#000000><img src=\"1x1.gif\" width=1></td>\n" .
       "<td>$font2<font color=#CC3366><B>64</td>\n" .
       "<td rowspan=$rowspan bgcolor=#000000><img src=\"1x1.gif\" width=1></td>\n" .
       "<th>$font2"."Community</th>\n" .
       "<td rowspan=$rowspan bgcolor=#000000><img src=\"1x1.gif\" width=1></td>\n" .
       "<th align=left>$font2"."Interface Name</th>\n" .
       "<th align=center>$font2"."Interface Alias</th>\n" .
       "<th align=center>$font2"."CIR (B/sec)</th>\n" .
       "<th align=center>$font2"."ifSpeed (b/sec)</th>\n" .
       "</tr>\n" .
       "<tr><td colspan=10 bgcolor=#000000><img src=\"1x1.gif\" height=1></td>\n</tr>\n";

// Returns array like: $oldiflist[community]=array("if1", "if2", ...)
// You have to match the old IF name against these after a "method" switch.
  $oldiflist=array();
  foreach ($communes as $c) {
    $sq="select distinct if_name from interfaces where hostname='$host' AND community='$c' order by if_name";
    $res=dosql($sq);
    if (! is_array($oldiflist[$c])) { $oldiflist[$c]=array(); }
    if (mysql_num_rows($res) > 0) {
      while ($row=mysql_fetch_array($res)) {
        $oldiflist[$c][]=ss($row["if_name"]);
      }
    }
  }
  $i=0;
  for (reset($newiflist); $c=key($newiflist); next($newiflist)) {
    if ($c=="-msgs-") {
      continue;
    }
    foreach ($newiflist[$c] as $newif) {
      $checked="";
      if ($m != $method) {
        $oldifname=$oldname[$c][$newif];
      } else {
        $oldifname=$newif;
      }
      if (in_array($oldifname, $oldiflist[$c])) {
        $checked=" checked";
      }
      $alias="";
      $v="";
      $cir=$dbspeed=$actspeed=$iffound=0;
      foreach ($interfaces[$host] as $harray) {
        if ($harray["community"]==$c && $harray["if_name"]==$oldifname) {
          $alias=$harray["alias"];
          $v=$harray["snmpv2"];
          $cir=number_format($harray["cir"]);
          $dbspeed=number_format($harray["speed"]);
          $iffound=1;
          break;
        }
      }
      $vfont="";
      $capable=0;
      if (check_64($host, $c, $nums[$c][$newif]) != "") {
        $vfont="<font color=#CC3366><B>";
        $capable = 1;
      }
      $vchecked=" checked";
      if ($v == "" && $iffound==1) { $vchecked=""; }
      if (trim($alias)=="") {
        $alias=$ifaliass[$oid["Alias"].".".$nums[$c][$newif]];
      }
      if ($ifspeeds[$oid["Speed"] . "." . $nums[$c][$newif]] != "") {
        $actspeed=number_format($ifspeeds[$oid["Speed"] . "." . $nums[$c][$newif]]);
      }
      if ($dbspeed==0 & $actspeed > 0) { $dbspeed=$actspeed; }
      if ($m != $method) {
        echo "<input type=hidden name=\"oldifname$i\" value=\"$oldifname\">\n";
      }
      if (trim($newif) != "") {
        echo "<td align=center><input type=checkbox name=\"do$i\" value=\"$c!$newif\"$checked></td>\n";
      } else {
        echo "<td align=center>$font<B>X<input type=hidden name=\"do$i\" value=\"\"></td>\n";
      }
      if ($capable==1) {
        echo "<td align=center><input type=checkbox name=\"v2_$i\" value=\"y\"$vchecked></td>\n";
      } else {
        echo "<td align=center>$font<B>X<input type=hidden name=\"v2_$i\" value=\"\"></td>\n";
      }
      echo "<td align=center>$font2$c</td>\n";
      if (trim($newif)=="") { $newif2="<I>Blank</I>"; } else { $newif2=$newif; }
      echo "<td align=left>$font2$vfont$newif2";
      if ($method != "ifDescr" && $ifdescr[$c][$nums[$c][$newif]] != "") {
        echo "<BR>\n<font size=2>({$ifdescr[$c][$nums[$c][$newif]]})</font>";
      }
      echo "</td>\n";
      echo "<td valign=top>$font2<input type=text name=\"alias$i\" size=30 value=\"$alias\"></td>\n";
      echo "<td valign=top>$font2<input type=text name=\"cir$i\" size=15 value=\"$cir\"></td>\n";
      echo "<td valign=top>$font2<input type=text name=\"speed$i\" size=15 value=\"$dbspeed\"></font>";
      if ($dbspeed != $actspeed) { 
        echo "<BR>\n$font1<font color=#CC0000><I>Actual:</I> $actspeed";
      }
      echo "</td></tr>\n<tr><td colspan=10 bgcolor=#000000><img src=\"1x1.gif\" height=1></td></tr>\n";
      $i++;
    }
  }
  echo "<input type=hidden name=\"count\" value=\"$i\">\n";
  echo "<tr><td colspan=10 align=center><input type=submit value=\" Go \"></td></tr>\n";
}
?>
</table>
</form>
<hr noshade size=1>
<P>
<a href="adm_hosts1.php">Host Administration</a><BR>
<a href="<? echo $location["admin"]; ?>/">Administration Menu</a>
</P>
</body></html>
